#include "systemtime.h"

SystemTime::SystemTime(QWidget *parent) :
    QWidget(parent)
{
    QRegExp timeToSendRegExp("[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]");
    validator = new QRegExpValidator(timeToSendRegExp);

    timeToSend = new QLineEdit();
    main_LAYOUT = new QGridLayout;

    currentTimePrefix_LABEL = new  QLabel(tr("Current System Time: 0x"));
    currentTime_LABEL = new  QLabel(tr("-"));
    timeToSend_LABEL = new QLabel("Arbitrary Time: 0x");

    timeToSend_LABEL->setAlignment(Qt::AlignRight);
    currentTimePrefix_LABEL->setAlignment(Qt::AlignRight);
    currentTime = 0x80000000;
    currentTime_LABEL->setText(QString::number(currentTime, 16));
    timeToSend->setMaxLength(8);
    timeToSend->setValidator(validator);
    timeToSend->setText("80000000");

    main_LAYOUT->addWidget(currentTimePrefix_LABEL, 0, 0, 1, 1);
    main_LAYOUT->addWidget(currentTime_LABEL, 0, 1, 1, 1);
    main_LAYOUT->addWidget(timeToSend_LABEL, 1, 0, 1, 1);
    main_LAYOUT->addWidget(timeToSend, 1, 1, 1, 1);
    main_LAYOUT->setColumnStretch(3, 1);
    main_LAYOUT->setRowStretch(2, 1);

    this->setLayout(main_LAYOUT);

    connect(this->timeToSend, SIGNAL(editingFinished()),
                                     this, SLOT(editingFinishedSLOT()));
}

void SystemTime::editingFinishedSLOT()
{
    emit (
    timeToSendChanged(timeToSend->text().toLong(0, 16))
    );
}

void SystemTime::systemTimeHasChanged(long time)
{
    currentTime = time;
    currentTime_LABEL->setText(QString::number(currentTime, 16));
}
